#include <stdio.h>

unsigned *DADIMSA;

/* dadims, dagetf and daputr for dynamic memory references. 
these should be in ltllib, but are needed only by ltlref.
these procedures implement simple dynamic memory allocation: 
dadims(nw,ng) allocates nw words of dynamic, setting ng to
number of words obtained (>=nw) or zero if allocation not
possible. daputr(i,v) sets i-th entry of dynamic memory area
to value v. dagetf(i) returns contents of i-th dynamic memory
location. Note that these are called from LITTLE, which is one
origin.
*/


dadims(nw,ng) /* allocate dynamic area of nw bytes */
unsigned *nw,*ng;
{
	unsigned i;
	char *calloc();

	DADIMSA = (unsigned *)calloc(*nw+1,sizeof(i)); /* point to area */

	if (DADIMSA==0) 	*ng = 0; 	/* indicate no words obtained */
	else		*ng = *nw; 	/* indicate success. */
}



dagetf(nb)	/* return contents of entry nb in dynamic area */
unsigned *nb;
{
	return DADIMSA[*nb];
}


daputr(i,v)	/* set i-th entry of dynamic area to v */
unsigned *i,*v;
{
	DADIMSA[*i] = *v;
}
