	.text
	.globl	anyc
	.globl	anys
	.globl	blds
	.globl	brkc
	.globl	brks
	.globl	ctlc
	.globl	ctuc
	.globl	nayc
	.globl	nays
	.globl	rbrc
	.globl	rbrs
	.globl	rpld
	.globl	rple
	.globl	rspc
	.globl	rsps
	.globl	spnc
	.globl	spns
	.globl	stlc
	.globl	stuc
#
# iss procedure to initialize for string search
# iss assumes ap addresses parameter list (s, sp, arg)
# where s is sds string, sp is string index, arg is longword value.
# if sp does not index valid character in s, then iss does
# sets r0 and executes ret, otherwise iss exits with
# r0 = 0
# r1 = value of third argument
# r2 = s adr
# r3 = starting address in ltllib_sds_ot
# r4 = sp
# r5 = sp, initial value for si
# r6 = (.len. s)
# 
	.align	1
iss:	clrl	r0			# assume result zero.
	movzwl	*4(ap),r6		# get string length.
	bgtr	iss2			# if length > 0.
iss1:	decl	r0			# set failure result.
# here if failure, do ret to return from caller of iss.
	ret				# exit string search.
iss2:	movl	*8(ap),r4		# load sp.
	beql	iss1			# if sp is zero.
	cmpw	r4,r6			# test that sp <= len.
	bgtr	iss1
	movl	4(ap),r2		# load address of sds.
	extzv	$21,$11,(r2),r3		# get word offset.
	mnegl	r3,r3			# negate to set backwards.
	moval	4(r2)[r3],r2		# set adr for sds.
	movab	ltllib_sds_ot[r4],r3	# get start adr in ot.
	decl	r3			# account for sp ones-origin.
	movl	*12(ap),r1		# get value of third arg.
	movl	r4,r5			# set initial value of si
	rsb				# return.
#
# anyc(c,ss) match if c in string set ss
#	.entry anyc,0
#
	.align	1
anyc:	.word	0
	clrl	r0			# assume no match
	movzbl	*4(ap),r1		# load character.
	bitw	ltllib_ss_tab[r1],*8(ap) # and with ss table.
	beql	anyc1			# if not in set
	incl	r0			# set result if in set.
anyc1:	ret
#
# anys(s, sp, ss) match any character in string set
#	.entry	anys,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
anys:	.word	0xfc
	bsbw	iss			# initialize
	movzbl	(r3),r7			# load sds offset.
	movzbl	(r2)[r7],r7		# load character.
	bitw	ltllib_ss_tab[r7],r1	# and with table entry.
	beqlu	anys1			# if not in set.
	incl	r0			# set return value if in set.
anys1:	ret
#
# blds(s, sm)  build string set for sm using string s
#	.entry	blds,^m<r2,r3,r4,r5,r6>
#
	.align	1
blds:	.word	0x7c
# reset definition to empty set.
	movzwl	*8(ap),r6		# load string set mask
	clrl	r2			# initialize loop index.
blds1:	bicw2	r6,ltllib_ss_tab[r2]	# clear old.
	aobleq	$255,r2,blds1		# loop if more chars.
# here to loop over s, setting bits for chars in s.
	movl	4(ap),r1		# load s adr.
	extzv	$21,$11,(r1),r2		# get word offset.
	mnegl	r2,r2			# negate to set backwards.
	moval	4(r1)[r2],r1		# set s1 adr.
	movab	ltllib_sds_ot,r3	# load start adr in ot
	movzwl	*4(ap),r5		# load string length.
blds2:	movzbl	(r3)+,r4		# load sds offset.
	movzbl	(r1)[r4],r4		# load character.
	bisw2	r6,ltllib_ss_tab[r4]	# add to string set.
	sobgtr	r5,blds2		# loop if more chars.
	ret
#
# brkc(s, sp, ch) break to character ch
#	.entry	brkc,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
brkc:	.word	0xfc
	bsbw	iss			# initialize
	subl3	r4,r6,r7		# compute length to scan.
	incl	r7			# ...
# use movtuc with offset table to scan for break character.
	movtuc	r7,(r3),r1,(r2),r7,ltllib_sds_wa1
	bvs	brkc1			# if break char found.
# here if no break char, r0 is zero, so decrement and return.
	decl	r0			# indicate no break char.
	ret
brkc1:	# here if break char, r0 contains chars remaining
	# including the break character.
	subl3	r0,r7,r0		# compute number matched
					# = length - remaining.
	ret
#
# brks(s, sp, ss)  break to character in string set.
#	.entry	brks,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
brks:	.word	0xfc
	bsbw	iss			# initialize.
	decl	r0			# assume will fail.
brks1:	movzbl	(r3)+,r7		# load sds offset.
	movzbl	(r2)[r7],r7		# load next character.
	bitw	ltllib_ss_tab[r7],r1	# and with table entry.
	bnequ	brks2			# if a break character.
	aobleq	r6,r5,brks1
	ret				# return (no match).
brks2:	subl3	r4,r5,r0		# return length matched.
	ret
#
# ctlc(c) convert c to lower case.
#	.entry	ctlc,0
#
	.align	1
ctlc:	.word	0
	movzbl	*4(ap),r0		# load character.
	movzbl	ltllib_ss_tlc[r0],r0	# convert to lower case.
	ret
#
# ctuc(c) convert c to upper case.
#	.entry	ctuc,0
#
	.align	1
ctuc:	.word	0
	movzbl	*4(ap),r0		# load character.
	movzbl	ltllib_ss_tuc[r0],r0	# convert to upper case.
	ret
#
# nayc(c,ss) match if c not in string set ss
#	.entry	nayc,0
#
	.align	1
nayc:	.word	0
	clrl	r0			# assume no match
	movzbl	*4(ap),r1		# load character.
	bitw	ltllib_ss_tab[r1],*8(ap) # and with ss table.
	bnequ	nayc1			# if in set
	incl	r0			# set result if not in set.
nayc1:	ret				# return.
#
# nays(s, sp, ss) match any character not in string set
#	.entry	nays,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
nays:	.word	0xfc
	bsbw	iss			# initialize
	movzbl	(r3),r7			# load sds offset.
	movzbl	(r2)[r7],r7		# load character.
	bitw	ltllib_ss_tab[r7],r1	# and with table entry.
	bnequ	nays1			# if in set.
	incl	r0			# set return value if not in set.
nays1:	ret
#
# rbrc(s, sp, ch) break to character ch
#	.entry	rbrc,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
rbrc:	.word	0xfc
	bsbw	iss			# initialize
	decl	r0			# assume will fail.
	incl	r3			# prepare for loop predecrement.
rbrc1:	movzbl	-(r3),r7		# load sds offset.
	movzbl	(r2)[r7],r7		# load next character.
	cmpb	r1,r7			# compare with break char.
	beqlu	rbrc2			# if break character.
	sobgtr	r5,rbrc1		# loop if more chars.
	ret
rbrc2:	subl3	r5,r4,r0		# return length of match.
	ret
#
# rbrs(s, sp, ss)  break to character in string set.
#	.entry	rbrs,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
rbrs:	.word	0xfc
	bsbw	iss			# initialize.
	decl	r0			# assume will fail.
	incl	r3			# prepare for predecr in loop.
rbrs1:	movzbl	-(r3),r7		# load sds offset.
	movzbl	(r2)[r7],r7		# load next character.
	bitw	ltllib_ss_tab[r7],r1	# and with table entry.
	bnequ	rbrs2			# if a break character.
	sobgtr	r5,rbrs1		# loop if more.
	ret				# return (no match).
rbrs2:	subl3	r5,r4,r0		# return length matched.
	ret
#
# rpld(s1,s2) define replacement string for rple
#	.entry	rpld,^m<r2,r3,r4,r5,r6>
#
	.align	1
rpld:	.word	0x7c
	clrl	r0			# assume success.
	movl	$255,r1			# set loop count.
rpld1:	movb	r1,ltllib_ss_rpl[r1]	# define entry.
	sobgeq	r1,rpld1		# loop if more.
# check that lengths of strings agree.
	movzwl	*4(ap),r6		# load length s1.
	cmpw	r6,*8(ap)		# compare lengths.
	beql	rpld2			# if lengths equal.
	decl	r0			# fail if lengths differ.
	ret
rpld2:	tstl	r6			# see if length zero.
	bneq	rpld3			# if nonzero.
	ret
rpld3:	movl	4(ap),r1		# load adr of s1.
	extzv	$21,$11,(r1),r3		# get origin offset.
	mnegl	r3,r3			# negate to set backwards.
	moval	4(r1)[r3],r1		# set s1 adr.
	movl	8(ap),r2		# load adr of s2.
	extzv	$21,$11,(r2),r3		# get origin offset.
	mnegl	r3,r3			# negate to set backwards.
	moval	4(r2)[r3],r2		# set s2 adr.
	movab	ltllib_sds_ot,r3	# set initial ot adr.
rpld4:	movzbl	(r3)+,r4		# load ot offset.
	movzbl	(r1)[r4],r5		# load char of s1.
	movb	(r2)[r4],ltllib_ss_rpl[r5] # enter translation.
	sobgtr	r6,rpld4		# loop if more chars.
	ret
#
# rple(s) translate string using tranlate table defined by rpld
#	.entry	rple,^m<r2,r3,r4,r5>
#
	.align	1
rple:	.word	0x3c
	movl	4(ap),r5		# load address of sds.
	extzv	$21,$11,(r5),r1		# get string length.
	mnegl	r1,r4			# adjust sds adr to start.
	moval	4(r5)[r4],r5		# ...
	movzwl	*4(ap),r3		# load string length.
	beql	rple1			# done if null string.
	addl2	$3,r3			# round up to multiple of 4
	bicl2	$3,r3			# ...
# translate string.
	movtc	r3,(r5),$32,ltllib_ss_rpl,r3,(r5)
rple1:	ret
#
# rspc(s, sp, ch) span character ch.
#	.entry	rspc,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
rspc:	.word	0xfc
	bsbw	iss			# initialize.
	incl	r3			# prepare for predecr in loop.
rspc1:	movzbl	-(r3),r7		# load offset for sds.
#-smf-	movzbl	(r2)[r7],r7		# load next character.
#-smf-	cmpb	r7,r1			# compare with span char.
	cmpb	(r2)[r7],r1		# compare next char with span char.
	bneq	rspc2			# if not span character.
	sobgtr	r5,rspc1		# loop if more
rspc2:	subl3	r5,r4,r0		# compute length matched.
	bneq	rspc3			# if any matched.
	decl	r0			# fail if none matched.
rspc3:	ret				# return.
#
# rsps(s, sp, ss)  span characters in string set
#	.entry	rsps,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
rsps:	.word	0xfc
	bsbw	iss			# initialize.
	incl	r3			# prepare for predecr in loop.
rsps1:	movzbl	-(r3),r7		# load offset for sds.
	movzbl	(r2)[r7],r7		# load next character.
	bitw	ltllib_ss_tab[r7],r1	# and with table entry.
	beqlu	rsps2			# if not in string set.
	sobgtr	r5,rsps1		# loop if more chars.
rsps2:	subl3	r5,r4,r0		# compute length matched.
	bneq	rsps3			# if any matched.
	decl	r0			# fail if none matched.
rsps3:	ret				# return.
#
# spnc(s, sp, ch) span character ch.
#	.entry	spnc,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
spnc:	.word	0xfc
	bsbw	iss			# initialize.
spnc1:	movzbl	(r3)+,r7		# load offset for sds.
#-smf-	movzbl	(r2)[r7],r7		# load next character.
#-smf-	cmpb	r7,r1			# compare with span char.
	cmpb	(r2)[r7],r1		# compare next char with span char.
	bneq	spnc2			# if not span character.
	aobleq	r6,r5,spnc1		# loop if more
spnc2:	subl3	r4,r5,r0		# compute length matched.
	bneq	spnc3			# if any matched.
	decl	r0			# fail if none matched.
spnc3:	ret				# return.
#
# spns(s, sp, ss)  span characters in string set
#	.entry	spns,^m<r2,r3,r4,r5,r6,r7>
#
	.align	1
spns:	.word	0xfc
	bsbw	iss			# initialize.
spns1:	movzbl	(r3)+,r7		# load offset for sds.
	movzbl	(r2)[r7],r7		# load next character.
	bitw	ltllib_ss_tab[r7],r1	# and with table entry.
	beql	spns2			# if not in string set.
	aobleq	r6,r5,spns1		# loop if more.
spns2:	subl3	r4,r5,r0		# compute length matched.
	bneq	spns3			# if any matched.
	decl	r0			# fail if none matched.
spns3:	ret				# return.
#
# stlc(s) convert s to lower case.
#	.entry	stlc,^m<r2,r3,r4,r5>
#
	.align	1
stlc:	.word	0x3c
	movl	4(ap),r5		# load address of sds.
	extzv	$21,$11,(r5),r1		# get string length.
	mnegl	r1,r4			# adjust sds adr to start.
	moval	4(r5)[r4],r5		# ...
	movzwl	*4(ap),r3		# load string length.
	beql	stlc1			# done if null string.
	addl2	$3,r3			# round up to multiple of 4
	bicl2	$3,r3			# ...
# translate string.
	movtc	r3,(r5),$32,ltllib_ss_tlc,r3,(r5)
stlc1:	ret
#
# stuc(s) convert s to upper case.
#	.entry	stuc,^m<r2,r3,r4,r5>
#
	.align	1
stuc:	.word	0x3c
	movl	4(ap),r5		# load address of sds.
	extzv	$21,$11,(r5),r1		# get string length.
	mnegl	r1,r4			# adjust sds adr to start.
	moval	4(r5)[r4],r5		# ...
	movzwl	*4(ap),r3		# load string length.
	beql	stuc1			# done if null string.
	addl2	$3,r3			# round up to multiple of 4
	bicl2	$3,r3			# ...
# translate string.
	movtc	r3,(r5),$32,ltllib_ss_tuc,r3,(r5)
stuc1:	ret
