	.text
	.globl	bskp_li
#
# this implementation enhances lex performance by setting symbol
# bskp_env in lex so that bskp called to skip over blanks when beginning
# token.  calling sequence is as follows:
#	call bskp_li(iwds, nowdp, nc10, nowc, nowd, c, tallyeol);
# consult lex source for exact meaning of parameters, nowc is index of
# column from which for non-separator is to begin.  exit values of
# variables nowdp, nc10, and nowd are functions of exit value of nowc.
# c is the non-separator encountered.  if the next non-separator is $,
# then bskp sets nowc to indicate end-of-line as is also done if rest of
# line contains separators.
# 
# author:  d. shields  (nyu-cims)  15-aug-79
# revise:  s. freudenberger  (nyu-cims)  12-dec-83
#	complete adjustment for use under 4.2bsd unix.  note that s32u
#	uses primary case lower (mcl), so fold leading character found
#	below to lower case.
#
#	.entry	bskp_li,^m<r2,r3,r4,r5>
#
	.align	1
bskp_li: .word	0x3c
# work with decremented nowc within procedure to account for little
# ones-origin.
	subl3	$1,*16(ap),r1		# get decremented nowc.
	cmpl	r1,$71			# see if end of line.
	bleq	bskp1			# if chars in current line.
	ret
bskp1:	movl	4(ap),r2		# get iwds adr (source txt).
	movab	ltllib_sds_ot[r1],r3	# get initial ot adr.
bskp2:	# here to search for non-separator.
	movzbl	(r3)+,r4		# load offset for char.
	movzbl	(r2)[r4],r5		# get next character.
	bitw	$2,ltllib_ss_tab[r5]	# see if separator.
	beql	bskp3			# if not separator.
	aobleq	$71,r1,bskp2		# loop if more chars.
# here if rest of line contains separators. set nowc to force read of
# next card.
	movl	$73,*16(ap)		# indicate end of line.
	ret
bskp3:	# here if non-separator. test for $ comment character.
	cmpb	$36,r5			# see if $
	bneq	bskp4			# if not comment.
# here if $, set to nowc to indicate end of line, and return blank as
# char so will then force call to givecr.
	incl	*28(ap)			# adjust comment count.
	movl	$73,*16(ap)		# signal end of line.
	ret
bskp4:	# here to update values on finding non-separator.
# store character c converted to lower-case.  this differs from vms.
	movzbl	ltllib_ss_tlc[r5],*24(ap)	# store char c.
	ashl	$-2,r1,r3		# convert nowc to word count.
	movl	(r2)[r3],*20(ap)	# store nowd.
	addl3	$1,r3,*8(ap)		# store nowdp.
	addl3	$2,r1,*16(ap)		# store nowc.
	bicl2	$~3,r4			# compute nc10.
	ashl	$3,r4,r4		# convert to bit count.
	addl3	$1,r4,*12(ap)		# store nc10.
	ret
