	.text
	.globl	casi_mw
#
# implement character string assignment procedure casmw in little lib in
# macro.  calling sequence is as follows:
#	call casi_mw(ax, ay, az, at);  $ .s. ax, ay, at = az;
# author:  d. shields  (nyu-cims)  16-aug-79
#
#	.entry	casi_mw,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
#
	.align	1
casi_mw: .word	0xffc
# verify that arguments correctly formed.
	pushl	$25			# call vstr_mw(az, 25);
	movl	sp,r11			# ...
	pushl	r11			# ...
	pushl	12(ap)			# ...
	calls	$2,vstr_mw		# ...
# save length, address of source arg.
	movq	r0,r6			# copy length/address.
# verify destination string.
	pushl	$26			# call vstr_mw(at, 26).
	movl	sp,r11			# ...
	pushl	r11			# ...
	pushl	16(ap)			# ...
	calls	$2,vstr_mw		# ...
	movq	r0,r8			# copy length/address.
	movl	*4(ap),r10		# get starting position.
	bgtr	casi1			# if starting position > 0.
# here to report error.
	pushl	$23			# call eror_mw(23);
	movl	sp,r11			# ...
	pushl	r11			# ...
	calls	$1,eror_mw		# ...
	ret
casi1:	movl	*8(ap),r11		# get length.
	bgeq	casi2			# if length non-negative.
# here to report error if length negative.
	pushl	$24			# call eror_mw(24);
	movl	sp,r11			# ...
	pushl	r11			# ...
	calls	$1,eror_mw		# ...
	ret
casi2:	#here to check that last char of dst is valid position.
	addl3	r10,r11,r1		# get last pos.
	decl	r1			# ...
	cmpl	r1,r8			# compare with true length.
	bleq	casi3			# if valid position.
# here to report error.
	pushl	$27			# call error_mw(27).
	movl	sp,r1			# ...
	pushl	r1			# ...
	calls	$1,eror_mw		# ...
casi3:	# update src address.
	tstl	r11			# test length.
	beql	casi8			# if assigning null length.
# now account for starting position.
	decl	r10			# make position zero-origin.
# load initial addresses for offset tables.
	movab	ltllib_sds_ot,r1	# offset for src.
	movab	(r1)[r10],r3		# offset for dst.
	tstl	r6			# test source length.
	beql	casi6			# if source null.
# here to move chars from source.
	movl	r11,r0			# move desired count to loop counter.
	cmpw	r11,r6			# compare with available count.
	bleq	casi4			# if source has all needed.
	movl	r6,r0			# else move avail chars.
# loop to copy available characters from source.
casi4:	subl2	r0,r11			# account for chars in source.
casi5:	movzbl	(r1)+,r2		# get offset for src.
	movzbl	(r3)+,r4		# get offset for dst.
	movb	(r7)[r2],(r9)[r4]	# move character.
	sobgtr	r0,casi5		# loop if more source chars.
casi6:	# here to pad dst if needed.
	tstl	r11			# see if padding needed.
	beql	casi8			# if no padding needed.
# pad out dst with blanks.
casi7:	movzbl	(r3)+,r4		# get dst offset.
	movb	$32,(r9)[r4]		# store blank.
	sobgtr	r11,casi7		# if more padding needed.
casi8:	ret
