	.text
	.globl	ccat_mw
#
# implement character concatencation procedure catmw in little lib in
# macro.  calling sequence is as follows:
#	call ccat_mw(ax, ay, at);  $  t = x .cc. y;
# author:  d. shields  (nyu-cims)  16-aug-79
#
#	.entry	ccat_mw,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
#
	.align	1
ccat_mw: .word	0xffc
# verify that arguments correctly formed.
	pushl	$15			# call vstr_mw(ax, 15);
	movl	sp,r11			# ...
	pushl	r11			# ...
	pushl	4(ap)			# ...
	calls	$2,vstr_mw		# ...
# save length, address of first arg.
	movq	r0,r6			# copy length/address.
	pushl	$16			# call vstr_mw(ay, 16).
	movl	sp,r11			# ...
	pushl	r11			# ...
	pushl	8(ap)			# ...
	calls	$2,vstr_mw		# ...
	movq	r0,r8			# copy length/address.
	addl3	r6,r8,r10		# compute result length.
	movl	12(ap),r11		# get result adr.
	movl	r10,(r11)		# store result length.
	beql	ccat4			# if result null.
# here to set origin of result.
	addl3	$3,r10,r1		# round up to multiple of cpw
	bicl3	$3,r1,r2		# ...
	ashl	$3,r2,r3		# convert to bit count.
	addw3	$33,r3,2(r11)		# store origin field.
# update result adr.
	mnegl	r2,r2			# negate to point backwards.
	movab	(r11)[r2],r11		# adjust address.
	tstl	r6			# test for null first arg.
	beql	ccat1			# if null.
# here to move first argument to result. use movc to move
# integral number of words, since first arg begins on word
# boundary, and update addresses.
	addl3	$3,r6,r10		# get rounded byte count.
	bicl2	$3,r10			# ...
	movc3	r10,(r7),(r11)		# move words.
	bicl3	$3,r6,r1		# compute address offset.
	movab	(r11)[r1],r11		# update result address.
ccat1:	# here to move second result.
	tstl	r8			# see if second arg null.
	beql	ccat4			# done if second arg null.
# here to move second arg.  there are two cases:
# 1. if first argument length exact number of words, can use
#    movc3 to move second argument to result.
# 2. otherwise, must move second argument by character.
	bicl3	$~3,r6,r2		# test first arg length
	bneq	ccat2			# if need long move.
# here to move block of chars.
	addl3	$3,r8,r1		# round to multiple of cpw.
	bicl2	$3,r1			# ...
	movc3	r1,(r9),(r11)		# do move.
	ret				# return.
ccat2:	# here to move second arg char by char.
	movab	ltllib_sds_ot,r1	# get initial at adr for arg.
	movab	(r1)[r2],r3		# get ot adr for result.
# loop to move second arg.
ccat3:	movzbl	(r1)+,r2		# get offset for input.
	movzbl	(r3)+,r4		# get offset for result.
	movb	(r9)[r2],(r11)[r4]	# move char.
	sobgtr	r8,ccat3		# loop if more to move.
ccat4:	# merge here to return.
	ret
