	.text
	.globl	cext_mw
#
# implement character string extraction procedure cexmw in little lib in
# macro.  calling sequence is as follows:
#	call cext_mw(ax, ay, az, at);  $ at = .s. ax, ay, az
# author:  d. shields  (nyu-cims)  19-aug-79
#
#	.entry	cext_mw,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
#
	.align	1
cext_mw: .word	0xffc
# verify that arguments correctly formed.
	pushl	$22			# call vstr_mw(az, 22);
	movl	sp,r11			# ...
	pushl	r11			# ...
	pushl	12(ap)			# ...
	calls	$2,vstr_mw		# ...
	movq	r0,r6			# save length/address of src.
	movl	*4(ap),r10		# get ax.
	bgtr	cext1			# if ax>=1.
# here to report error.
	pushl	$19			# call errmw(19);
	movl	sp,r11			# ...
	pushl	r11			# ...
	calls	$1,eror_mw		# ...
	ret
cext1:	# here to test that ay>=0.
	movl	*8(ap),r11		# get ay, substring length.
	bgeq	cext2			# if ay>=0.
# here to report error.
	pushl	$20			# call eror_mw(20);
	movl	sp,r11			# ...
	pushl	r11			# ...
	calls 	$1,eror_mw		# ...
	ret
cext2:	# here to test that last char is in fact in dst string.
	addl3	r10,r11,r1		# ...
	decl	r1			# index of last char in dst.
	cmpw	r1,r6			# see if valid.
	bleq	cext3			# if valid.
# here to report error.
	pushl	$21			# call eror_mw(21)
	movl	sp,r11			# ...
	pushl	r11			# ...
	calls	$1,eror_mw		# ...
	ret
cext3:	# here if inputs consistent. set length and origin of result.
	movl	16(ap),r9		# get adr of result.
	movl	r11,(r9)		# set length of result.
	beql	cext6			# if null result.
	addl3	$3,r11,r1		# compute origin.
	bicl3	$3,r1,r2		# ...
	ashl	$3,r2,r3		# convert to bit count.
	addw3	$33,r3,2(r9)		# store origin.
# adjust destination address.
	mnegl	r2,r4			# negate to point backwards.
	movab	(r9)[r4],r9		# update dst address.
# if source starts at word boundary, can use movc3 to move words.
	subl3	$1,r10,r1		# convert start pos to zero-org
	bicl3	$~3,r1,r3		# get position in word.
	bneq	cext4			# if not at start of word.
# here to move integral number of words.
# update dst adr address to point to correct word.
	bicl3	$3,r1,r3	# get word count.
	movc3	r2,(r7)[r3],(r9)
	ret
cext4:	# here to move character by character.
	movab	ltllib_sds_ot,r3	# get ot adr for dst.
	movab	(r3)[r1],r1		# get ot adr for src.
# loop to move characters.
cext5:	movzbl	(r1)+,r2		# get offset for src.
	movzbl	(r3)+,r4		# get offset for dst.
	movb	(r7)[r2],(r9)[r4]	# move character.
	sobgtr	r11,cext5		# loop if more to move.
# merge here to return.
cext6:	ret
