	.text
	.globl	cind_mw
#
# implement character comparison procedure cinmw in little lib in macro.
# calling sequence is as follows:
#	v = cind_mw(ax, ay);  $ ax .in. ay
# author:  d. shields  (nyu-cims)  16-aug-79
#
#	.entry	cind_mw,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
#
	.align	1
cind_mw: .word	0xffc
# verify that arguments correctly formed.
	pushl	$17			# call vstr_mw(ax, 15);
	movl	sp,r11			# save sp.
	pushl	r11
	pushl	4(ap)			# ...
	calls	$2,vstr_mw		# ...
# save length, address of first arg.
	movq	r0,r6			# copy length/address.
# verify second arg.
	pushl	$18			# call vstr_mw(ay, 16).
	movl	sp,r11			# save allocated address.
	pushl	r11			# push address.
	pushl	8(ap)			# ...
	calls	$2,vstr_mw		# ...
# cannot match if source is null.
	tstl	r6			# test length of first str.
	beql	cind1			# if null string.
	movq	r0,r8			# copy length/adr of ay.
	cmpw	r6,r8			# compare lengths
	bgtr	cind1			# if cannot match.
# use movtuc instruction to search target string ay for
# instance of first character of source string.
	movtuc	r8,ltllib_sds_ot,3(r7),(r9),r8,ltllib_sds_wa1
# if no instance found, v bit is clear, so return with no match.
	bvc	cind1
# here if first char in source occurs in target string.
# r0 contains number of characters remaining in target, including
# the matched character.
	subl3	r0,r8,r10		# compute number before first.
	movl	r0,r8			# update length of string.
# if number remaining less than number to match, cannot have match.
	cmpl	r0,r6			# compare lengths.
	blss	cind1			# if match not possible.
# translate source string and remainder of target string to
# standard order and then use matchc to finish search.
	movtc	r6,ltllib_sds_ot,$32,(r7),r6,ltllib_sds_wa1
	movab	ltllib_sds_wa2,r11	# get address of wa2.
	movtc	r8,ltllib_sds_ot[r10],$32,(r9),r8,(r11)
	matchc	r6,ltllib_sds_wa1,r8,(r11)
	bneq	cind1			# if no match.
# here if match, r2 is count of remaining chars in string not
# including the matched substring (this is not as described
# in hardware reference manual).
	subl3	r6,r8,r0		# r0 = len src - len sub.
	subl2	r2,r0			# r0 = len src - len sub - 
					# # chars left = rel. pos of
					# 1st char of sub.
	addl2	r10,r0			# add number before start of frst
	incl	r0			# account for first char.
	ret
cind1:	clrl	r0			# here if no match.
	ret
