	.text
	.globl	ifsa_li
#
#  this module provides support for special case by directly moving data
#  from line buffer to target sds string without need to use global
#  conversion buffer.  this routine is called from ifma_li as follows:
#
#	call ifsa_li(iolba, iolborg, lbp, datum, fw)
#
#  where iolba is line buffer, iolborg is index of start of line buffer
#  in iolba, lbp is position in line, datum is sds string and fw is
#  number of characters to move.
#
#  note that both iolba and datum are in little "reversed" character
#  order.  there are two cases:
#  1.  if lbp is positioned at start of word, then can do move of
#      appropriate number of words using movc.
#  2.  otherwise, can move line buffer to work area, and then move back.
#      two moves are needed to preserve reversed order.
# 
#	.entry	ifsa_li,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
#
	.align	1
ifsa_li: .word	0xffc
	movl	*20(ap),r11		# get length.
	movl	r11,*16(ap)		# set length in sds.
	bnequ	ifsa1			# if not null string.
	ret				# return.
ifsa1:	# here to enter origin in sds datum.
	addl3	$3,r11,r10		# convert to word count.
	ashl	$-2,r10,r10		# ...
	ashl	$5,r10,r9		# convert to bits.
	addl2	$32+1,r9		# ...
	movl	16(ap),r8		# load adr of sds.
	movw	r9,2(r8)		# store origin.
	mnegl	r10,r10			# set sds starting adr.
	moval	(r8)[r10],r10		# ...
# here to compute source address.
	movl	*8(ap),r9		# get lborg value.
	decl	r9			# account for ones-origin.
	moval	*4(ap)[r9],r9		# update src adr.
	movl	*12(ap),r8		# load lbp value.
	decl	r8			# account for ones-origin.
	bicl3	$3,r8,r7		# get word offset.
	movab	(r9)[r7],r9		# update src adr.
	bicl3	$~3,r8,r7		# get offset for lbp.
# see if lbp positioned at start of word.
	bnequ	ifsa2			# if not at start of word.
# here if lbp at start of word and so can move words.
# convert move count to move integral number of words.
	addl2	$3,r11			# round up byte count.
	bicl2	$3,r11			# ...
	movc3	r11,(r9),(r10)
	ret
ifsa2:	# here to move to std order and then back to sds.
	addl3	$3,r11,r6		# round up move length.
	bicl2	$3,r6			# ...
	movtc	r11,ltllib_sds_ot(r7),$32,(r9),r6,ltllib_sds_wa1
# move back, thus restoring sds order.
	movtc	r6,ltllib_sds_ot,$32,ltllib_sds_wa1,r6,(r10)
	ret
