	.text
	.globl	ofsa_li
#
#  this module implements that fast move directly from
#  sds datum to line buffer that requested by ofma if
#  no need to convert using global conversion buffer.
#
#  the routine is called in the form:
#
#	call ofsa_li(iolba, lborg, lbp, datum, nmov, npad);
#
#  where iolba is line buffer array, lborg gives origin in
#  iolba for first word of line buffer for current file,
#  lbp is position within line, datum is sds string,
#  nmov is number of characters to move from datum, and
#  npad is pad count of number of blanks that are then
#  to be moved to line buffer.
# 
#	.entry	ofsa_li,^m<r2,r3,r4,r5,r6,r7,r8,r9,r10,r11>
#
	.align	1
ofsa_li: .word	0xffc
	movl	16(ap),r10		# load adr of string.
	extzv	$21,$11,(r10),r9	# get word offset from sorg.
	mnegl	r9,r9			# negate to set backwards
	moval	4(r10)[r9],r10		# compute src adr.
	movl	*8(ap),r9		# load lborg value.
	decl	r9			# account for ones-origin.
	moval	*4(ap)[r9],r9		# update dst adr.
	movl	*12(ap),r11		# load lbp value.
	decl	r11			# account for ones-origin
	bicl3	$3,r11,r8		# adjust dst adr.
	movab	(r9)[r8],r9		# ...
	subl3	r8,r11,r8		# compute offset in wd for lbp.
	bnequ	ofsa1			# if not at left of word.
	tstl	*24(ap)			# test npad.
	bnequ	ofsa1			# if npad nonzero.
	movl	*20(ap),r11		# load move count
 	bicl3	$~3,r11,r7		# extract modulus mod 4
	bnequ	ofsa1			# if move count not exact.
# here if moving integral number of words
	movc3	r11,(r10),(r9)		# do the move.
	ret
ofsa1:	# here to move byte-by-byte.
# assume r10 is src adr, r9 is dst adr, r8 is dst offset.
	movab	ltllib_sds_ot,r7	# set src adr for ot.
	addl2	r7,r8			# set dst adr for ot.
	movl	*20(ap),r11		# load move count
	beqlu	ofsa3			# if move count zero.
ofsa2:	# here to move from datum.
	movzbl	(r7)+,r6		# load offset for src.
	movzbl	(r8)+,r5		# load offset for dst.
	movb	(r10)[r6],(r9)[r5]	# move byte.
	sobgtr	r11,ofsa2		# loop if more to move.
ofsa3:	# here to pad result.
	movl	*24(ap),r11		# load pad count.
	bnequ	ofsa4			# if pad count nonzero.
	ret
ofsa4:	# here to pad result.
	movzbl	(r8)+,r5		# load dst offset.
	movb	$32,(r9)[r5]		# insert blank.
	sobgtr	r11,ofsa4		# loop if more to move.
	ret
