	.text
	.globl	vstr_mw
#
# this is translation of little library procedure vcsmw to as.
# calling sequence is as follows:
#	call vstr_mw(ax, ernum);
# where ax is purported to be correctly formatted sds, and
# ernum is error number to be reported if ax ill-formed.
# author:  d. shields  (nyu-cims)  16-aug-79
# on exit:
#	(r0) = string length
# if string not null, then
#	(r1) = address of first word of string.
#
#	.entry	vstr_mw,^m<r2,r3>
#
	.align	1
vstr_mw: .word	0xc
	movl	4(ap),r1		# get adr of string.
	movzwl	(r1),r0			# get string length.
	bneq	vstr1			# if not null string.
	ret				# return if null string.
vstr1:	movzwl	2(r1),r2		# get origin.
	subl3	$33,r2,r2		# account for org bit, word.
	bicl3	$~31,r2,r3		# check that multiple of ws.
	bneq	vstr2			# if not multiple of ws.
	ashl	$-3,r2,r3		# get capacity.
	cmpl	r0,r3			# compare length, capacity.
	bgtr	vstr2			# if length exceeds capacity.
# here if well-formed, update (r1).
	mnegl	r3,r3			# negate to set backwards.
	movab	(r1)[r3],r1		# adjust str adr.
	ret
vstr2:	# here if error, call error processing routines.
	pushl	r1			# push address of string.
	calls	$1,eros_mw		# call to report adr.
	pushl	8(ap)			# push address of error num.
	calls	$1,eror_mw		# call to report error.
	ret
